package com.virtual.plat.server;

import com.virtual.common.FuncUtil;
import com.virtual.common.StringManager;
import com.virtual.plat.server.RequestData;
import com.virtual.plat.server.RequestHandler;
import com.virtual.plat.server.message.MessageMgr;
import com.virtual.plat.server.operlog.OperationLogMgr;
import com.virtual.plat.server.publiccloud.PublicCloudHandler;
import com.virtual.plat.server.virtualhost.DomainHandler;
import java.util.Date;
import java.util.Iterator;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.LinkedBlockingQueue;
import javax.annotation.PreDestroy;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

@Deprecated
public class CvmRequestProcessor implements Runnable {

   private static final int QUEUE_LEN = 1000;
   private Thread thread;
   private static Log log = LogFactory.getLog(CvmRequestProcessor.class);
   protected MessageMgr messageMgr = null;
   private static StringManager strMng = StringManager.getManager(MessageMgr.class);
   protected OperationLogMgr operationLogMgr = null;
   private BlockingQueue requestQueue;
   private boolean isBlocked;
   private DomainHandler domainHandler = null;
   private PublicCloudHandler publicCloudHandler = null;


   public CvmRequestProcessor(RequestHandler var1) {
      this.domainHandler = var1.domainHandler;
      this.publicCloudHandler = var1.publicCloudHandler;
      this.operationLogMgr = var1.operationLogMgr;
      this.messageMgr = var1.messageMgr;
      this.requestQueue = new LinkedBlockingQueue(1000);
      this.thread = new Thread(this, "CVM Request Processor Manager");
      this.thread.setDaemon(true);
      this.thread.start();
      this.isBlocked = true;
   }

   @PreDestroy
   public synchronized void stop() {
      this.thread.interrupt();

      try {
         this.thread.join();
      } catch (InterruptedException var1) {
         ;
      }

      this.thread = null;
   }

   public void run() {
      while(true) {
         while(true) {
            try {
               while(true) {
                  this.isBlocked = true;
                  RequestData var1;
                  if((var1 = (RequestData)this.requestQueue.take()).getMessageId() == 0L) {
                     try {
                        Thread.sleep(500L);
                     } catch (InterruptedException var3) {
                        ;
                     }
                  }

                  this.isBlocked = false;
                  if(var1.getStatus() != 0) {
                     Long var2;
                     Long.valueOf((var2 = (Long)var1.getData().get("cloudId")) == null?-1L:var2.longValue());
                     log.info("Request type:" + FuncUtil.convertTaskType(var1.getRequestType()));
                     this.messageMgr.updateMessage(var1.getMessageId(), new Date());
                     switch(var1.getRequestType()) {
                     case 21:
                        this.domainHandler.deleteDomain(var1);
                        break;
                     case 26:
                        this.domainHandler.repairVm(var1);
                        break;
                     case 30:
                        this.domainHandler.startDomain(var1);
                        break;
                     case 31:
                        this.domainHandler.closeDomain(var1);
                        break;
                     case 32:
                        this.domainHandler.shutdownDomain(var1);
                        break;
                     case 33:
                        this.domainHandler.restartDomain(var1);
                        break;
                     case 34:
                        this.domainHandler.pauseDomain(var1);
                        break;
                     case 47:
                        this.domainHandler.deployDomain(var1);
                        break;
                     case 58:
                        this.domainHandler.modifyDomainBasicInfo(var1);
                        break;
                     case 175:
                        this.domainHandler.handleVmHA(var1);
                        break;
                     case 190:
                        this.publicCloudHandler.SyncResourceFromPublicCloud(var1);
                     }
                  }
               }
            } catch (Exception var4) {
               log.error((Object)null, var4);
            }
         }
      }
   }

   public boolean isIdle() {
      return this.requestQueue.size() == 0 && this.isBlocked;
   }

   public Integer getSize() {
      return Integer.valueOf(this.requestQueue.size());
   }

   public int postRequest(RequestData var1) {
      byte var2 = 0;
      if(!this.requestQueue.offer(var1)) {
         log.error("Request queue is full!");
         var2 = -2;
      }

      return var2;
   }

   public boolean cancelRequest(Long var1) {
      Iterator var2 = this.requestQueue.iterator();

      RequestData var3;
      do {
         if(!var2.hasNext()) {
            return false;
         }
      } while((var3 = (RequestData)var2.next()).getMessageId() != var1.longValue());

      var3.setStatus(0);
      this.messageMgr.updateMessage(var3.getMessageId());
      var1 = (Long)var3.getData().get("id");
      byte var7;
      if(var3.getRequestType() >= 20) {
         var7 = 10;
      } else if(var3.getRequestType() >= 10) {
         var7 = 5;
      } else {
         var7 = 8;
      }

      try {
         String var4;
         int var5;
         if((var5 = (var4 = var3.getOperateDesc()).lastIndexOf("。")) > 0) {
            var4 = var4.substring(0, var5);
         } else if((var5 = var4.lastIndexOf(".")) > 0) {
            var4 = var4.substring(0, var5);
         }

         this.operationLogMgr.addFailureLog(var3.getLoginName(), var3.getUserName(), var3.getIpAddress(), var7, strMng.getString("task.cancel.operation", new Object[]{var4}), strMng.getString("task.cancel.msg"), var1);
      } catch (Exception var6) {
         log.error((Object)null, var6);
      }

      return true;
   }

}
